import { Component } from 'react';
import { TimeRange, TimeOptions, TimeOption } from '../../types/time';
import { Timezone } from '../../utils/datemath';
import { DateTime } from '../../utils/moment_wrapper';
export interface Props {
    value: TimeRange;
    options: TimeOptions;
    isTimezoneUtc: boolean;
    timezone?: Timezone;
    onChange?: (timeRange: TimeRange) => void;
}
export interface State {
    value: TimeRange;
    isFromInputValid: boolean;
    isToInputValid: boolean;
}
export declare class TimePickerPopover extends Component<Props, State> {
    static popoverClassName: string;
    constructor(props: Props);
    onFromInputChanged: (value: string, valid: boolean) => void;
    onToInputChanged: (value: string, valid: boolean) => void;
    onFromCalendarChanged: (value: DateTime) => void;
    onToCalendarChanged: (value: DateTime) => void;
    onTimeOptionClick: (timeOption: TimeOption) => void;
    onApplyClick: () => void;
    render(): JSX.Element;
}
