import { ComponentClass } from 'react';
import { NavModel } from './navModel';
import { PluginMeta, GrafanaPlugin } from './plugin';
export interface AppRootProps {
    meta: AppPluginMeta;
    path: string;
    query: {
        [s: string]: any;
    };
    /**
     * Pass the nav model to the container... is there a better way?
     */
    onNavChanged: (nav: NavModel) => void;
}
export interface AppPluginMeta extends PluginMeta {
}
export declare class AppPlugin extends GrafanaPlugin<AppPluginMeta> {
    root?: ComponentClass<AppRootProps>;
    rootNav?: NavModel;
    angularPages?: {
        [component: string]: any;
    };
    /**
     * Set the component displayed under:
     *   /a/${plugin-id}/*
     */
    setRootPage(root: ComponentClass<AppRootProps>, rootNav?: NavModel): this;
    setComponentsFromLegacyExports(pluginExports: any): void;
}
