import { DateTime } from '../utils/moment_wrapper';
export interface RawTimeRange {
    from: DateTime | string;
    to: DateTime | string;
}
export interface TimeRange {
    from: DateTime;
    to: DateTime;
    raw: RawTimeRange;
}
export interface AbsoluteTimeRange {
    from: number;
    to: number;
}
export interface IntervalValues {
    interval: string;
    intervalMs: number;
}
export interface TimeZone {
    raw: string;
    isUtc: boolean;
}
export declare const parseTimeZone: (raw: string) => TimeZone;
export declare const DefaultTimeZone: TimeZone;
export interface TimeOption {
    from: string;
    to: string;
    display: string;
    section: number;
    active: boolean;
}
export interface TimeOptions {
    [key: string]: TimeOption[];
}
export declare type TimeFragment = string | DateTime;
export declare const TIME_FORMAT = "YYYY-MM-DD HH:mm:ss";
