import { Field, FieldType } from '../types/index';
export interface IndexedField extends Field {
    index: number;
}
export declare class FieldCache {
    private fields;
    private fieldIndexByName;
    private fieldIndexByType;
    constructor(fields?: Field[]);
    addField(field: Field): void;
    hasFieldOfType(type: FieldType): boolean;
    getFields(type?: FieldType): IndexedField[];
    getFieldByIndex(index: number): IndexedField | null;
    getFirstFieldOfType(type: FieldType): IndexedField | null;
    hasFieldNamed(name: string): boolean;
    getFieldByName(name: string): IndexedField | null;
}
