import { LogLevel } from '../types/logs';
import { SeriesData } from '../types/data';
/**
 * Returns the log level of a log line.
 * Parse the line for level words. If no level is found, it returns `LogLevel.unknown`.
 *
 * Example: `getLogLevel('WARN 1999-12-31 this is great') // LogLevel.warn`
 */
export declare function getLogLevel(line: string): LogLevel;
export declare function addLogLevelToSeries(series: SeriesData, lineIndex: number): SeriesData;
