/// <reference types="react" />
export interface DateTimeBuiltinFormat {
    __momentBuiltinFormatBrand: any;
}
export declare const ISO_8601: DateTimeBuiltinFormat;
export declare type DateTimeInput = Date | string | number | Array<string | number> | DateTime;
export declare type FormatInput = string | DateTimeBuiltinFormat | undefined;
export declare type DurationInput = string | number | DateTimeDuration;
export declare type DurationUnit = 'year' | 'years' | 'y' | 'month' | 'months' | 'M' | 'week' | 'weeks' | 'w' | 'day' | 'days' | 'd' | 'hour' | 'hours' | 'h' | 'minute' | 'minutes' | 'm' | 'second' | 'seconds' | 's' | 'millisecond' | 'milliseconds' | 'ms' | 'quarter' | 'quarters' | 'Q';
export interface DateTimeLocale {
    firstDayOfWeek: () => number;
}
export interface DateTimeDuration {
    asHours: () => number;
}
export interface DateTime extends Object {
    add: (amount?: DateTimeInput, unit?: DurationUnit) => DateTime;
    diff: (amount: DateTimeInput, unit?: DurationUnit, truncate?: boolean) => number;
    endOf: (unitOfTime: DurationUnit) => DateTime;
    format: (formatInput?: FormatInput) => string;
    fromNow: (withoutSuffix?: boolean) => string;
    from: (formaInput: DateTimeInput) => string;
    isSame: (input?: DateTimeInput, granularity?: DurationUnit) => boolean;
    isValid: () => boolean;
    local: () => DateTime;
    locale: (locale: string) => DateTime;
    startOf: (unitOfTime: DurationUnit) => DateTime;
    subtract: (amount?: DateTimeInput, unit?: DurationUnit) => DateTime;
    toDate: () => Date;
    toISOString: () => string;
    valueOf: () => number;
    unix: () => number;
    utc: () => DateTime;
}
export declare const setLocale: (language: string) => void;
export declare const getLocaleData: () => DateTimeLocale;
export declare const isDateTime: (value: any) => value is DateTime;
export declare const toUtc: (input?: string | number | Date | import("react").ReactText[] | DateTime | undefined, formatInput?: FormatInput) => DateTime;
export declare const toDuration: (input?: string | number | DateTimeDuration | undefined, unit?: "s" | "year" | "years" | "y" | "month" | "months" | "M" | "week" | "weeks" | "w" | "day" | "days" | "d" | "hour" | "hours" | "h" | "minute" | "minutes" | "m" | "second" | "seconds" | "millisecond" | "milliseconds" | "ms" | "quarter" | "quarters" | "Q" | undefined) => DateTimeDuration;
export declare const dateTime: (input?: string | number | Date | import("react").ReactText[] | DateTime | undefined, formatInput?: FormatInput) => DateTime;
