import { SeriesData, TimeSeries, FieldType, TableData } from '../types/index';
/**
 * Given a value this will guess the best column type
 *
 * TODO: better Date/Time support!  Look for standard date strings?
 */
export declare function guessFieldTypeFromValue(v: any): FieldType;
/**
 * Looks at the data to guess the column type.  This ignores any existing setting
 */
export declare function guessFieldTypeFromSeries(series: SeriesData, index: number): FieldType | undefined;
/**
 * @returns a copy of the series with the best guess for each field type
 * If the series already has field types defined, they will be used
 */
export declare const guessFieldTypes: (series: SeriesData) => SeriesData;
export declare const isTableData: (data: any) => data is SeriesData;
export declare const isSeriesData: (data: any) => data is SeriesData;
export declare const toSeriesData: (data: any) => SeriesData;
export declare const toLegacyResponseData: (series: SeriesData) => TableData | TimeSeries;
export declare function sortSeriesData(data: SeriesData, sortIndex?: number, reverse?: boolean): SeriesData;
